﻿Public Class frmCollection
    'After playing with this I decided to play a little more with data conversion otherwise known as casting
    Private Sub btnUntypedCollection_Click(sender As Object, e As EventArgs) Handles btnUntypedCollection.Click
        'Experiment with making one of the grades string instead of numeric - see page 258 and on
        Dim grades As New ArrayList
        grades.Add(txtGrade1.Text)
        grades.Add(txtGrade2.Text)
        grades.Add(txtGrade3.Text)
        Dim gradeTot As Integer = 0
        Dim gradeAvg As Decimal = 0
        Dim grade As Integer
        For indx As Integer = 0 To grades.Count - 1
            gradeTot = gradeTot + grade                     'the error happens at this point
        Next
        gradeAvg = gradeTot / 3
        txtAverage.Text = gradeAvg
    End Sub

    Private Sub btnTypedCollection_Click(sender As Object, e As EventArgs) Handles btnTypedCollection.Click
        'Experiment with making one of the grades string instead of numeric - see page 258 and on
        'My results are a little different - experiment - it is more where the error happens that I am seeing
        'Note that they use literals in the book - experiment with using a literal as opposed to a textbox content
        Dim grades As New List(Of Integer)
        grades.Add(txtGrade1.Text)
        grades.Add(txtGrade2.Text)    'if I enter a letter here then the error happens at this point
        'grades.Add(txtGrade3.Text)
        grades.Add("D")               'if I comment out the txtGrade3 and use this the error happens at this point
        Dim gradeTot As Integer = 0
        Dim gradeAvg As Decimal = 0
        For indx As Integer = 0 To grades.Count - 1
            gradeTot = gradeTot + grades(indx)
        Next
        gradeAvg = gradeTot / 3
        txtAverage.Text = gradeAvg
    End Sub

    Private Sub btnCreate_Click(sender As Object, e As EventArgs) Handles btnCreate.Click
        Dim theGrades As New List(Of Integer) From
              {80, 90, 70, 100}
        Dim theDisplay As String = ""
        Dim totGrades As Integer
        Dim avgGrades As Decimal
        For Each theGrade In theGrades
            theDisplay &= theGrade.ToString & vbCrLf
            totGrades += theGrade
        Next
        avgGrades = totGrades / theGrades.Count
        theDisplay &= vbCrLf & "Average " & avgGrades.ToString & vbCrLf & vbCrLf
        MessageBox.Show(theDisplay)
        theGrades.Add(txtGrade4.Text)
        theGrades.Add(txtGrade5.Text)
        theGrades.Insert(0, 100)
        totGrades = 0
        avgGrades = 0
        For Each theGrade In theGrades
            theDisplay &= theGrade.ToString & vbCrLf
            totGrades += theGrade
        Next
        avgGrades = totGrades / theGrades.Count
        theDisplay &= vbCrLf & "Average " & avgGrades.ToString & vbCrLf
        MessageBox.Show(theDisplay)
        Dim toRemove As Integer = 70
        If theGrades.Contains(toRemove) Then
            theGrades.Remove(toRemove)
        End If
        theGrades.RemoveAt(1)
        totGrades = 0
        avgGrades = 0
        For Each theGrade In theGrades
            theDisplay &= theGrade.ToString & vbCrLf
            totGrades += theGrade
        Next
        avgGrades = totGrades / theGrades.Count
        theDisplay &= vbCrLf & "Average " & avgGrades.ToString & vbCrLf
        MessageBox.Show(theDisplay)
        theGrades.Sort()
        For Each theGrade In theGrades
            theDisplay &= theGrade.ToString & vbCrLf
        Next
        MessageBox.Show(theDisplay)
        Dim toFind As Integer = 88
        Dim whereFound As Integer = theGrades.BinarySearch(toFind)
        MessageBox.Show(whereFound)
    End Sub
End Class
